=== debian/changelog ===
wireguard-linux-compat (1.0.20200611-1ubuntu1~19.10.1) eoan; urgency=medium

  * Backport latest upstream packages to focal. (LP: #1883877)
    - drop back to debhelper-compat (= 12)
  * Bodge round undetectable incompatibility between 5.3.0-51 and 5.3.0-53 ABI
    in Ubuntu.  (Patch by Jason A. Donenfeld <Jason@zx2c4.com>).

 -- Andy Whitcroft <apw@ubuntu.com>  Wed, 17 Jun 2020 12:07:03 +0100

wireguard-linux-compat (1.0.20200611-1) unstable; urgency=medium

  * New upstream release.

 -- Unit 193 <unit193@debian.org>  Tue, 16 Jun 2020 02:26:59 -0400
