=== debian/control ===
Source: wireguard-linux-compat
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Uploaders:
 Unit 193 <unit193@debian.org>,
Build-Depends:
 debhelper-compat (= 12),
 dkms,
Standards-Version: 4.5.0
Homepage: https://www.wireguard.com
Vcs-Git: https://salsa.debian.org/debian/wireguard-linux-compat.git
Vcs-Browser: https://salsa.debian.org/debian/wireguard-linux-compat
Rules-Requires-Root: no

Package: wireguard-dkms
Architecture: all
Section: kernel
Depends:
 ${misc:Depends},
 ${perl:Depends},
Recommends:
 wireguard (>= 0.0.20191219),
 wireguard-tools (>= 0.0.20191219),
Description: fast, modern, secure kernel VPN tunnel (DKMS version)
 WireGuard is a novel VPN that runs inside the Linux Kernel and uses
 state-of-the-art cryptography (the "Noise" protocol). It aims to be
 faster, simpler, leaner, and more useful than IPSec, while avoiding
 the massive headache. It intends to be considerably more performant
 than OpenVPN. WireGuard is designed as a general purpose VPN for
 running on embedded interfaces and super computers alike, fit for
 many different circumstances. It runs over UDP.
 .
 This package uses DKMS to automatically build the wireguard kernel
 module.
