## wireguard-linux-compat 1.0.20200623

=== debian/changelog ===
wireguard-linux-compat (1.0.20200623-1) unstable; urgency=medium

  * New upstream release.

 -- Unit 193 <unit193@debian.org>  Wed, 24 Jun 2020 23:49:15 -0400
