## wireguard-linux-compat 1.0.20200712

=== debian/changelog ===
wireguard-linux-compat (1.0.20200712-1) unstable; urgency=medium

  * New upstream release.

 -- Unit 193 <unit193@debian.org>  Tue, 14 Jul 2020 17:15:33 -0400
