## wireguard-linux-compat 1.0.20200908

=== debian/changelog ===
wireguard-linux-compat (1.0.20200908-1) unstable; urgency=medium

  * New upstream release.
    - Refresh patch.

 -- Unit 193 <unit193@debian.org>  Tue, 08 Sep 2020 19:36:39 -0400
