=== debian/changelog ===
wireguard-linux-compat (1.0.20201112-1~20.10.1) groovy; urgency=medium

  * Backport latest upstream packages to groovy (LP: #1905325).
    - Update compatibility layer to support upstream stable changes.

 -- Andy Whitcroft <apw@ubuntu.com>  Mon, 23 Nov 2020 20:29:58 +0000

wireguard-linux-compat (1.0.20201112-1) unstable; urgency=medium

  * New upstream release.

 -- Unit 193 <unit193@debian.org>  Fri, 13 Nov 2020 19:27:49 -0500
