## wireguard-linux-compat 1.0.20210124

=== debian/changelog ===
wireguard-linux-compat (1.0.20210124-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Unit 193 <unit193@debian.org>  Mon, 01 Feb 2021 14:21:55 -0500

wireguard-linux-compat (1.0.20210124-1) unstable; urgency=medium

  * New upstream release.

 -- Unit 193 <unit193@debian.org>  Mon, 25 Jan 2021 22:37:18 -0500

wireguard-linux-compat (1.0.20201221-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Unit 193 <unit193@debian.org>  Mon, 11 Jan 2021 03:32:10 -0500

wireguard-linux-compat (1.0.20201112-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Unit 193 <unit193@debian.org>  Mon, 23 Nov 2020 20:46:35 -0500

wireguard-linux-compat (1.0.20200908-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Unit 193 <unit193@debian.org>  Tue, 15 Sep 2020 19:26:21 -0400

wireguard-linux-compat (1.0.20200712-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Unit 193 <unit193@debian.org>  Tue, 21 Jul 2020 20:23:24 -0400

wireguard-linux-compat (1.0.20200623-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Unit 193 <unit193@debian.org>  Wed, 01 Jul 2020 03:16:19 -0400

wireguard-linux-compat (1.0.20200611-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Unit 193 <unit193@debian.org>  Sun, 21 Jun 2020 19:37:47 -0400

wireguard-linux-compat (1.0.20200520-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Unit 193 <unit193@debian.org>  Mon, 08 Jun 2020 20:49:58 -0400

wireguard-linux-compat (1.0.20200506-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Unit 193 <unit193@debian.org>  Fri, 22 May 2020 03:50:01 -0400

wireguard-linux-compat (1.0.20200429-2~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 01 May 2020 13:38:54 -0400

wireguard-linux-compat (1.0.20200429-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports. (Closes: #959157)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 30 Apr 2020 20:38:54 -0400

wireguard-linux-compat (0.0.20200318-1~bpo10+1) buster-backports; urgency=medium

  * prepare debian backports release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Sat, 28 Mar 2020 08:12:04 -0400

wireguard-linux-compat (0.0.20200215-2~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 06 Mar 2020 00:10:59 -0500
