=== debian/changelog ===
wireguard-linux-compat (1.0.20210219-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Unit 193 <unit193@debian.org>  Wed, 03 Mar 2021 22:50:25 -0500

wireguard-linux-compat (1.0.20210219-1) unstable; urgency=medium

  * New upstream release.

 -- Unit 193 <unit193@debian.org>  Fri, 19 Feb 2021 20:34:22 -0500
