=== debian/control ===
--- 
+++ 
@@ -1,16 +1,15 @@
 Source: wireguard-linux-compat
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
+Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
 Uploaders:
  Unit 193 <unit193@debian.org>,
 Build-Depends:
  debhelper-compat (= 13),
  dkms,
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://www.wireguard.com
-Vcs-Git: https://salsa.debian.org/debian/wireguard-linux-compat.git
+Vcs-Git: https://salsa.debian.org/debian/wireguard-linux-compat.git -b debian/buster-backports
 Vcs-Browser: https://salsa.debian.org/debian/wireguard-linux-compat
 Rules-Requires-Root: no
