=== debian/changelog ===
wireguard-linux-compat (1.0.20210606-1) unstable; urgency=medium

  * New upstream release.

 -- Unit 193 <unit193@debian.org>  Fri, 13 Aug 2021 17:28:08 -0400
