=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
  dkms,
 Standards-Version: 4.5.1
 Homepage: https://www.wireguard.com
-Vcs-Git: https://salsa.debian.org/debian/wireguard-linux-compat.git -b debian/buster-backports
+Vcs-Git: https://salsa.debian.org/debian/wireguard-linux-compat.git
 Vcs-Browser: https://salsa.debian.org/debian/wireguard-linux-compat
 Rules-Requires-Root: no
